import { EvaluationReason } from './EvaluationMetadata';
import type { EvaluationDetails } from './EvaluationMetadata';
import type { StickyValues } from './utils/StickyValuesStorage';
export default class ConfigEvaluation {
    value: boolean;
    rule_id: string;
    secondary_exposures: Record<string, string>[];
    json_value: Record<string, unknown>;
    explicit_parameters: string[] | null;
    config_delegate: string | null;
    undelegated_secondary_exposures: Record<string, string>[];
    is_experiment_group: boolean;
    group_name: string | null;
    evaluation_details: EvaluationDetails;
    constructor(value: boolean, rule_id: string, secondary_exposures?: Record<string, string>[], json_value?: Record<string, unknown> | boolean, explicit_parameters?: string[] | null, config_delegate?: string | null);
    withGroupName(name: string | null): this;
    withEvaluationDetails(reason: EvaluationReason, time: number): ConfigEvaluation;
    setIsExperimentGroup(isExperimentGroup?: boolean): void;
    static fromSticky(stickyValue: StickyValues): ConfigEvaluation;
    getJSONValue(): StickyValues;
}
