export declare const ExceptionEndpoint = "https://statsigapi.net/v1/sdk_exception";
type ExtraDataExtractor = () => Promise<Record<string, unknown>>;
export default class ErrorBoundary {
    private readonly _sdkKey;
    private _statsigMetadata?;
    private _seen;
    constructor(sdkKey: string);
    _setStatsigMetadata(statsigMetadata: Record<string, string | number>): void;
    _swallow<T>(tag: string, task: () => T): void;
    _capture<T>(tag: string, task: () => T, recover: () => T, getExtraData?: ExtraDataExtractor): T;
    _logError(tag: string, error: unknown, getExtraData?: ExtraDataExtractor): void;
    private _onCaught;
    private _getDescription;
}
export {};
