import ConfigEvaluation from './ConfigEvaluation';
import { ConfigSpec } from './ConfigSpec';
import { EvaluationDetails, EvaluationReason } from './EvaluationMetadata';
import { GetExperimentOptions, GetLayerOptions } from './StatsigClient';
import StatsigSDKOptions from './StatsigSDKOptions';
import { StatsigUser } from './StatsigUser';
export default class Evaluator {
    private store;
    private options;
    constructor(options: StatsigSDKOptions);
    getFeatureGate(gateName: string): ConfigSpec | null;
    getConfigSpec(configName: string): ConfigSpec | null;
    getConfig(user: StatsigUser, configName: string, options?: GetExperimentOptions): ConfigEvaluation;
    checkGate(user: StatsigUser, gateName: string): ConfigEvaluation;
    getLayer(user: StatsigUser, layerName: string, options?: GetLayerOptions): ConfigEvaluation;
    getGlobalEvaluationDetails(): EvaluationDetails;
    setInitializeValues(initializeValues: Record<string, unknown>, reason: EvaluationReason): void;
    private evalConfigSpec;
    private evalAndSaveToPersistentStorage;
    private evalAndDeleteFromPersistentStorage;
    private evalLayerWithPersistedValues;
    private allocatedExperimentExistsAndIsActive;
    private evalConfigWithPersistedValues;
    private _eval;
    private _evalDelegate;
    private _evalPassPercent;
    private _evalRule;
    private _evalCondition;
}
