"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var Layer = /** @class */ (function () {
    function Layer(user, name, layerValue, ruleID, evaluationDetails, logParameterFunction, secondaryExposures, undelegatedSecondaryExposures, allocatedExperimentName, explicitParameters, groupName) {
        if (logParameterFunction === void 0) { logParameterFunction = null; }
        if (secondaryExposures === void 0) { secondaryExposures = []; }
        if (undelegatedSecondaryExposures === void 0) { undelegatedSecondaryExposures = []; }
        if (allocatedExperimentName === void 0) { allocatedExperimentName = null; }
        if (explicitParameters === void 0) { explicitParameters = []; }
        if (groupName === void 0) { groupName = null; }
        this._user = user;
        this._logParameterFunction = logParameterFunction;
        this._name = name;
        this._value = JSON.parse(JSON.stringify(layerValue !== null && layerValue !== void 0 ? layerValue : {}));
        this._ruleID = ruleID !== null && ruleID !== void 0 ? ruleID : '';
        this._evaluationDetails = evaluationDetails;
        this._secondaryExposures = secondaryExposures;
        this._undelegatedSecondaryExposures = undelegatedSecondaryExposures;
        this._allocatedExperimentName = allocatedExperimentName;
        this._explicitParameters = explicitParameters;
        this._groupName = groupName;
    }
    Layer._create = function (user, name, value, ruleID, evaluationDetails, logParameterFunction, secondaryExposures, undelegatedSecondaryExposures, allocatedExperimentName, explicitParameters, groupName) {
        if (logParameterFunction === void 0) { logParameterFunction = null; }
        if (secondaryExposures === void 0) { secondaryExposures = []; }
        if (undelegatedSecondaryExposures === void 0) { undelegatedSecondaryExposures = []; }
        if (allocatedExperimentName === void 0) { allocatedExperimentName = null; }
        if (explicitParameters === void 0) { explicitParameters = []; }
        if (groupName === void 0) { groupName = null; }
        return new Layer(user, name, value, ruleID, evaluationDetails, logParameterFunction, secondaryExposures, undelegatedSecondaryExposures, allocatedExperimentName, explicitParameters, groupName);
    };
    Layer.prototype.get = function (key, defaultValue, typeGuard) {
        var _this = this;
        var def = defaultValue !== null && defaultValue !== void 0 ? defaultValue : null;
        var val = this._value[key];
        if (val == null) {
            // @ts-ignore
            return def;
        }
        var logAndReturn = function () {
            _this._logLayerParameterExposure(key);
            return val;
        };
        if (typeGuard) {
            // @ts-ignore
            return typeGuard(val) ? logAndReturn() : def;
        }
        if (def == null) {
            return logAndReturn();
        }
        if (typeof val === typeof def &&
            Array.isArray(def) === Array.isArray(val)) {
            return logAndReturn();
        }
        return def;
    };
    Layer.prototype.getValue = function (key, defaultValue) {
        if (defaultValue == undefined) {
            defaultValue = null;
        }
        var val = this._value[key];
        if (val != null) {
            this._logLayerParameterExposure(key);
        }
        return val !== null && val !== void 0 ? val : defaultValue;
    };
    Layer.prototype._logLayerParameterExposure = function (parameterName) {
        var _a;
        (_a = this._logParameterFunction) === null || _a === void 0 ? void 0 : _a.call(this, this, parameterName);
    };
    return Layer;
}());
exports.default = Layer;
