"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.INIT_TIMEOUT_DEFAULT_MS = exports.DEFAULT_EVENT_LOGGING_API = exports.DEFAULT_CONFIG_SPEC_API = void 0;
exports.DEFAULT_CONFIG_SPEC_API = 'https://api.statsigcdn.com/v1/download_config_specs/';
exports.DEFAULT_EVENT_LOGGING_API = 'https://events.statsigapi.net/v1/rgstr';
exports.INIT_TIMEOUT_DEFAULT_MS = 3000;
var StatsigSDKOptions = /** @class */ (function () {
    function StatsigSDKOptions(options) {
        var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k;
        if (options == null) {
            options = {};
        }
        this.configSpecAPI = (_a = options.configSpecAPI) !== null && _a !== void 0 ? _a : exports.DEFAULT_CONFIG_SPEC_API;
        this.eventLoggingAPI = (_b = options.eventLoggingAPI) !== null && _b !== void 0 ? _b : exports.DEFAULT_EVENT_LOGGING_API;
        this.disableCurrentPageLogging = (_c = options.disableCurrentPageLogging) !== null && _c !== void 0 ? _c : false;
        this.environment = (_d = options.environment) !== null && _d !== void 0 ? _d : null;
        this.loggingIntervalMillis = this.normalizeNumberInput(options.loggingIntervalMillis, {
            default: 10000,
            min: 1000,
            max: 60000,
        });
        this.loggingBufferMaxSize = this.normalizeNumberInput(options.loggingBufferMaxSize, {
            default: 100,
            min: 2,
            max: 500,
        });
        this.disableNetworkKeepalive = (_e = options.disableNetworkKeepalive) !== null && _e !== void 0 ? _e : false;
        this.overrideStableID = (_f = options.overrideStableID) !== null && _f !== void 0 ? _f : null;
        this.localMode = (_g = options.localMode) !== null && _g !== void 0 ? _g : false;
        this.disableLocalStorage = (_h = options.disableLocalStorage) !== null && _h !== void 0 ? _h : false;
        this.ignoreWindowUndefined = (_j = options === null || options === void 0 ? void 0 : options.ignoreWindowUndefined) !== null && _j !== void 0 ? _j : false;
        this.userPersistentStorage = (_k = options === null || options === void 0 ? void 0 : options.userPersistentStorage) !== null && _k !== void 0 ? _k : null;
        this.initTimeoutMs = exports.INIT_TIMEOUT_DEFAULT_MS;
        if (options.initTimeoutMs != null) {
            var statsigOptions = options;
            this.initTimeoutMs =
                statsigOptions.initTimeoutMs && statsigOptions.initTimeoutMs >= 0
                    ? statsigOptions.initTimeoutMs
                    : exports.INIT_TIMEOUT_DEFAULT_MS;
        }
        this.initializeValues = null;
        if (options.initializeValues != null) {
            this.initializeValues = options.initializeValues;
        }
    }
    StatsigSDKOptions.prototype.normalizeNumberInput = function (input, bounds) {
        if (input == null) {
            return bounds.default;
        }
        return Math.max(Math.min(input, bounds.max), bounds.min);
    };
    return StatsigSDKOptions;
}());
exports.default = StatsigSDKOptions;
