import type { EvaluationDetails } from './EvaluationMetadata';
import { EvaluationReason } from './EvaluationMetadata';
import StatsigSDKOptions from './StatsigSDKOptions';
import { ConfigSpec } from './ConfigSpec';
export default class StatsigStore {
    private lcut;
    private reason;
    private featureGates;
    private dynamicConfigs;
    private layerConfigs;
    private options;
    constructor(options: StatsigSDKOptions);
    setInitializeValues(initializeValues: Record<string, any>, reason: EvaluationReason): void;
    private saveToLocalStorage;
    private loadFromLocalStorage;
    getLastUpdateTime(): number;
    setEvaluationReason(evalReason: EvaluationReason): void;
    setConfigSpecs(values: Record<string, unknown>, updatedReason: EvaluationReason): boolean;
    getDynamicConfig(configName: string): ConfigSpec | null;
    getFeatureGate(gateName: string): ConfigSpec | null;
    getLayerConfig(layerName: string): ConfigSpec | null;
    getGlobalEvaluationDetails(): EvaluationDetails;
}
