"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.EvaluationReason = exports.DynamicConfig = void 0;
var DynamicConfig_1 = __importDefault(require("./DynamicConfig"));
var Layer_1 = __importDefault(require("./Layer"));
var StatsigClient_1 = __importDefault(require("./StatsigClient"));
var EvaluationMetadata_1 = require("./EvaluationMetadata");
var DynamicConfig_2 = require("./DynamicConfig");
Object.defineProperty(exports, "DynamicConfig", { enumerable: true, get: function () { return __importDefault(DynamicConfig_2).default; } });
var EvaluationMetadata_2 = require("./EvaluationMetadata");
Object.defineProperty(exports, "EvaluationReason", { enumerable: true, get: function () { return EvaluationMetadata_2.EvaluationReason; } });
var Statsig = /** @class */ (function () {
    function Statsig() {
    }
    Statsig.initializeAsync = function (sdkKey, options) {
        var _a;
        return __awaiter(this, void 0, void 0, function () {
            var inst;
            return __generator(this, function (_b) {
                inst = (_a = Statsig.instance) !== null && _a !== void 0 ? _a : new StatsigClient_1.default(sdkKey, options);
                if (!Statsig.instance) {
                    Statsig.instance = inst;
                }
                return [2 /*return*/, inst.initializeAsync()];
            });
        });
    };
    Statsig.initialize = function (sdkKey, options) {
        var _a;
        var inst = (_a = Statsig.instance) !== null && _a !== void 0 ? _a : new StatsigClient_1.default(sdkKey, options);
        if (!Statsig.instance) {
            Statsig.instance = inst;
        }
        return inst.initialize(options.initializeValues);
    };
    // Gate
    Statsig.checkGate = function (user, gateName, options) {
        var _a, _b;
        return (_b = (_a = Statsig.instance) === null || _a === void 0 ? void 0 : _a.checkGate(user, gateName, options)) !== null && _b !== void 0 ? _b : false;
    };
    Statsig.manuallyLogGateExposure = function (user, gateName) {
        var _a;
        (_a = Statsig.instance) === null || _a === void 0 ? void 0 : _a.logGateExposure(user, gateName);
    };
    // Config
    Statsig.getConfig = function (user, configName) {
        var _a, _b;
        return ((_b = (_a = Statsig.instance) === null || _a === void 0 ? void 0 : _a.getConfig(user, configName)) !== null && _b !== void 0 ? _b : new DynamicConfig_1.default(configName, {}, '', null, this.getEvaluationDetails()));
    };
    Statsig.manuallyLogConfigExposure = function (user, configName) {
        var _a;
        (_a = Statsig.instance) === null || _a === void 0 ? void 0 : _a.logConfigExposure(user, configName);
    };
    // Experiment
    Statsig.getExperiment = function (user, experimentName, options) {
        var _a, _b;
        return ((_b = (_a = Statsig.instance) === null || _a === void 0 ? void 0 : _a.getExperiment(user, experimentName, options)) !== null && _b !== void 0 ? _b : new DynamicConfig_1.default(experimentName, {}, '', null, this.getEvaluationDetails()));
    };
    Statsig.manuallyLogExperimentExposure = function (user, configName) {
        var _a;
        (_a = Statsig.instance) === null || _a === void 0 ? void 0 : _a.logExperimentExposure(user, configName);
    };
    Statsig.loadUserPersistedValues = function (user, idType) {
        var _a, _b;
        return (_b = (_a = Statsig.instance) === null || _a === void 0 ? void 0 : _a.loadUserPersistedValues(user, idType)) !== null && _b !== void 0 ? _b : {};
    };
    Statsig.loadUserPersistedValuesAsync = function (user, idType) {
        var _a, _b;
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0: return [4 /*yield*/, ((_a = Statsig.instance) === null || _a === void 0 ? void 0 : _a.loadUserPersistedValuesAsync(user, idType))];
                    case 1: return [2 /*return*/, ((_b = (_c.sent())) !== null && _b !== void 0 ? _b : {})];
                }
            });
        });
    };
    // Layer
    Statsig.getLayer = function (user, layerName, options) {
        var _a, _b;
        return ((_b = (_a = Statsig.instance) === null || _a === void 0 ? void 0 : _a.getLayer(user, layerName, options)) !== null && _b !== void 0 ? _b : Layer_1.default._create(user, layerName, {}, '', this.getEvaluationDetails()));
    };
    Statsig.manuallyLogLayerParameterExposure = function (user, layerName, parameterName) {
        var _a;
        (_a = Statsig.instance) === null || _a === void 0 ? void 0 : _a.logLayerParameterExposure(user, layerName, parameterName);
    };
    Statsig.logEvent = function (user, eventName, value, metadata) {
        var _a;
        if (value === void 0) { value = null; }
        if (metadata === void 0) { metadata = null; }
        return (_a = Statsig.instance) === null || _a === void 0 ? void 0 : _a.logEvent(user, eventName, value, metadata);
    };
    Statsig.shutdown = function () {
        var _a;
        (_a = Statsig.instance) === null || _a === void 0 ? void 0 : _a.shutdown();
        Statsig.instance = null;
    };
    /**
     * @returns The Statsig stable ID used for device level experiments
     */
    Statsig.getStableID = function () {
        var _a, _b;
        return (_b = (_a = Statsig.instance) === null || _a === void 0 ? void 0 : _a.getStableID()) !== null && _b !== void 0 ? _b : '';
    };
    /**
     *
     * @returns The reason and time associated with the evaluation for the current set
     * of gates and configs
     */
    Statsig.getEvaluationDetails = function () {
        var _a, _b;
        return ((_b = (_a = Statsig.instance) === null || _a === void 0 ? void 0 : _a.getEvaluationDetails()) !== null && _b !== void 0 ? _b : {
            reason: EvaluationMetadata_1.EvaluationReason.Uninitialized,
            time: 0,
        });
    };
    /**
     *
     * @returns true if initialize has already been called, false otherwise
     */
    Statsig.initializeCalled = function () {
        return Statsig.instance != null && Statsig.instance.initializeCalled();
    };
    Statsig.instance = null;
    return Statsig;
}());
exports.default = Statsig;
