export declare enum DiagnosticsEvent {
    START = "start",
    END = "end"
}
export declare enum DiagnosticsKey {
    OVERALL = "overall",
    INITIALIZE = "initialize",
    INITIALIZE_WITH_DELTA = "initialize_with_delta"
}
export type Primitive = string | number | boolean | null | undefined;
export type PrimitiveRecords = Record<string, Primitive>;
export type DiagnosticsMarkers = {
    context: string;
    markers: PrimitiveRecords[];
    metadata: PrimitiveRecords;
};
export default class Diagnostics {
    private markers;
    private context;
    private metadata;
    constructor(context: string);
    getMarkers(): DiagnosticsMarkers;
    addMetadata(key: string, value: Primitive): void;
    mark(key: DiagnosticsKey, action: DiagnosticsEvent, step?: string | null, value?: Primitive): void;
}
