import { UserPersistentStorageInterface } from '../StatsigSDKOptions';
import { StatsigUser } from '../StatsigUser';
export type StickyValues = {
    value: boolean;
    rule_id: string;
    json_value: Record<string, unknown>;
    secondary_exposures: Record<string, string>[];
    explicit_parameters: string[] | null;
    config_delegate: string | null;
    undelegated_secondary_exposures: Record<string, string>[];
    group_name: string | null;
    time: number;
};
export type UserPersistedValues = Record<string, StickyValues>;
export default class StickyValuesStorage {
    static storageInterface: UserPersistentStorageInterface | null;
    static getAll(user: StatsigUser, idType: string): UserPersistedValues | null;
    static getAsync(user: StatsigUser, idType: string): Promise<UserPersistedValues | null>;
    static save(user: StatsigUser, idType: string, experimentName: string, userStickyValues: StickyValues): void;
    static delete(user: StatsigUser, idType: string, configName: string): void;
    private static getStorageKey;
}
