"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var EvaluationUtils_1 = __importDefault(require("./EvaluationUtils"));
var StickyValuesStorage = /** @class */ (function () {
    function StickyValuesStorage() {
    }
    StickyValuesStorage.getAll = function (user, idType) {
        if (this.storageInterface === null) {
            return null;
        }
        var key = this.getStorageKey(user, idType);
        try {
            return this.storageInterface.load(key);
        }
        catch (e) {
            console.debug("Failed to load key (".concat(key, ") from user persisted storage"), e);
        }
        return null;
    };
    StickyValuesStorage.getAsync = function (user, idType) {
        return __awaiter(this, void 0, void 0, function () {
            var key, e_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (this.storageInterface == null) {
                            return [2 /*return*/, null];
                        }
                        key = this.getStorageKey(user, idType);
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, this.storageInterface.loadAsync(key)];
                    case 2: return [2 /*return*/, _a.sent()];
                    case 3:
                        e_1 = _a.sent();
                        console.debug("Failed to loadAsync key (".concat(key, ") from user persisted storage"), e_1);
                        return [3 /*break*/, 4];
                    case 4: return [2 /*return*/, null];
                }
            });
        });
    };
    StickyValuesStorage.save = function (user, idType, experimentName, userStickyValues) {
        if (this.storageInterface == null) {
            return;
        }
        var key = this.getStorageKey(user, idType);
        try {
            var value = JSON.stringify(userStickyValues);
            this.storageInterface.save(key, experimentName, value);
        }
        catch (e) {
            console.debug("Failed to save key (".concat(key, ") to user persisted storage"), e);
        }
    };
    StickyValuesStorage.delete = function (user, idType, configName) {
        if (this.storageInterface == null) {
            return;
        }
        var persistedValue = StickyValuesStorage.getAll(user, idType);
        if (persistedValue != null) {
            delete persistedValue[configName];
            var key = this.getStorageKey(user, idType);
            this.storageInterface.delete(key, configName);
        }
    };
    StickyValuesStorage.getStorageKey = function (user, idType) {
        return "".concat(String(EvaluationUtils_1.default.getUnitID(user, idType)), ":").concat(idType);
    };
    StickyValuesStorage.storageInterface = null;
    return StickyValuesStorage;
}());
exports.default = StickyValuesStorage;
